OpenShot Audio Library | OpenShotAudio: juce::CachedValue< Type > Class Template Reference

OpenShot Audio Library | OpenShotAudio 0.3.1

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::CachedValue< Type > Class Template Reference

`#include <juce_CachedValue.h>`

Inheritance diagram for juce::CachedValue< Type >:

## Public Member Functions
| CachedValue ()
| CachedValue (ValueTree &tree, const Identifier &propertyID, UndoManager *undoManager)
| CachedValue (ValueTree &tree, const Identifier &propertyID, UndoManager *undoManager, const Type &defaultToUse)
| operator Type () const noexcept
Type | get () const noexcept
Type & | operator* () noexcept
Type * | operator-> () noexcept
template<typename OtherType >
bool | operator== (const OtherType &other) const
template<typename OtherType >
bool | operator!= (const OtherType &other) const
Value | getPropertyAsValue ()
bool | isUsingDefault () const
Type | getDefault () const
CachedValue & | operator= (const Type &newValue)
void | setValue (const Type &newValue, UndoManager *undoManagerToUse)
void | resetToDefault ()
void | resetToDefault (UndoManager *undoManagerToUse)
void | setDefault (const Type &value)
void | referTo (ValueTree &tree, const Identifier &property, UndoManager *um)
void | referTo (ValueTree &tree, const Identifier &property, UndoManager *um, const Type &defaultVal)
void | forceUpdateOfCachedValue ()
ValueTree & | getValueTree () noexcept
const Identifier & | getPropertyID () const noexcept
UndoManager * | getUndoManager () noexcept

## Detailed Description

template<typename Type>
class juce::CachedValue< Type >

This class acts as a typed wrapper around a property inside a ValueTree.

A CachedValue provides an easy way to read and write a ValueTree property with a chosen type. So for example a CachedValue<int> allows you to read or write the property as an int, and a CachedValue<String> lets you work with it as a String.

It also allows efficient access to the value, by caching a copy of it in the type that is being used.

You can give the CachedValue an optional UndoManager which it will use when writing to the underlying ValueTree.

If the property inside the ValueTree is missing, the CachedValue will automatically return an optional default value, which can be specified when initialising the CachedValue.

To create one, you can either use the constructor to attach the CachedValue to a ValueTree, or can create an uninitialised CachedValue with its default constructor and then attach it later with the referTo() methods.

Common types like String, int, double which can be easily converted to a var should work out-of-the-box, but if you want to use more complex custom types, you may need to implement some template specialisations of VariantConverter which this class uses to convert between the type and the ValueTree's internal var.

Definition at line 59 of file juce_CachedValue.h.

## Constructor & Destructor Documentation

## ◆ CachedValue() [1/3]

template<typename Type >

juce::CachedValue< Type >::CachedValue | ( |  | ) |
| inlinedefault

Default constructor. Creates a default CachedValue not referring to any property. To initialise the object, call one of the referTo() methods.

## ◆ CachedValue() [2/3]

template<typename Type >

juce::CachedValue< Type >::CachedValue | ( | ValueTree & | tree,
|  | const Identifier & | propertyID,
|  | UndoManager * | undoManager
| ) |  |
| inline

Constructor.

Creates a CachedValue referring to a Value property inside a ValueTree. If you use this constructor, the fallback value will be a default-constructed instance of Type.

Parameters

  tree | The ValueTree containing the property
  propertyID | The identifier of the property
  undoManager | The UndoManager to use when writing to the property

Definition at line 212 of file juce_CachedValue.h.

## ◆ CachedValue() [3/3]

template<typename Type >

juce::CachedValue< Type >::CachedValue | ( | ValueTree & | tree,
|  | const Identifier & | propertyID,
|  | UndoManager * | undoManager,
|  | const Type & | defaultToUse
| ) |  |
| inline

Constructor.

Creates a default Cached Value referring to a Value property inside a ValueTree, and specifies a fallback value to use if the property does not exist.

Parameters

  tree | The ValueTree containing the property
  propertyID | The identifier of the property
  undoManager | The UndoManager to use when writing to the property
  defaultToUse | The fallback default value to use.

Definition at line 220 of file juce_CachedValue.h.

## Member Function Documentation

## ◆ forceUpdateOfCachedValue()

template<typename Type >

void juce::CachedValue< Type >::forceUpdateOfCachedValue
| inline

Force an update in case the referenced property has been changed from elsewhere.

Note: The CachedValue is a ValueTree::Listener and therefore will be informed of changes of the referenced property anyway (and update itself). But this may happen asynchronously. forceUpdateOfCachedValue() forces an update immediately.

Definition at line 282 of file juce_CachedValue.h.

## ◆ get()

template<typename Type >

Type juce::CachedValue< Type >::get | ( |  | ) | const
| inlinenoexcept

Returns the current value of the property. If the property does not exist, returns the fallback default value.

Definition at line 106 of file juce_CachedValue.h.

## ◆ getDefault()

template<typename Type >

Type juce::CachedValue< Type >::getDefault | ( |  | ) | const
| inline

Returns the current fallback default value.

Definition at line 138 of file juce_CachedValue.h.

## ◆ getPropertyAsValue()

template<typename Type >

Value juce::CachedValue< Type >::getPropertyAsValue
| inline

Returns the current property as a Value object.

Definition at line 228 of file juce_CachedValue.h.

## ◆ getPropertyID()

template<typename Type >

const Identifier & juce::CachedValue< Type >::getPropertyID | ( |  | ) | const
| inlinenoexcept

Returns the property ID of the referenced property.

Definition at line 182 of file juce_CachedValue.h.

## ◆ getUndoManager()

template<typename Type >

UndoManager * juce::CachedValue< Type >::getUndoManager | ( |  | ) |
| inlinenoexcept

Returns the UndoManager that is being used.

Definition at line 185 of file juce_CachedValue.h.

## ◆ getValueTree()

template<typename Type >

ValueTree & juce::CachedValue< Type >::getValueTree | ( |  | ) |
| inlinenoexcept

Returns a reference to the ValueTree containing the referenced property.

Definition at line 179 of file juce_CachedValue.h.

## ◆ isUsingDefault()

template<typename Type >

bool juce::CachedValue< Type >::isUsingDefault
| inline

Returns true if the current property does not exist and the CachedValue is using the fallback default value instead.

Definition at line 234 of file juce_CachedValue.h.

## ◆ operator Type()

template<typename Type >

juce::CachedValue< Type >::operator Type | ( |  | ) | const
| inlinenoexcept

Returns the current value of the property. If the property does not exist, returns the fallback default value.

This is the same as calling get().

Definition at line 101 of file juce_CachedValue.h.

## ◆ operator!=()

template<typename Type >
template<typename OtherType >

bool juce::CachedValue< Type >::operator!= | ( | const OtherType & | other | ) | const
| inline

Returns true if the current value of the property (or the fallback value) is not equal to other.

Definition at line 126 of file juce_CachedValue.h.

## ◆ operator*()

template<typename Type >

Type & juce::CachedValue< Type >::operator* | ( |  | ) |
| inlinenoexcept

Dereference operator. Provides direct access to the property.

Definition at line 109 of file juce_CachedValue.h.

## ◆ operator->()

template<typename Type >

Type * juce::CachedValue< Type >::operator-> | ( |  | ) |
| inlinenoexcept

Dereference operator. Provides direct access to members of the property if it is of object type.

Definition at line 114 of file juce_CachedValue.h.

## ◆ operator=()

template<typename Type >

CachedValue< Type > & juce::CachedValue< Type >::operator= | ( | const Type & | newValue | ) |
| inline

Sets the property. This will actually modify the property in the referenced ValueTree.

Definition at line 240 of file juce_CachedValue.h.

## ◆ operator==()

template<typename Type >
template<typename OtherType >

bool juce::CachedValue< Type >::operator== | ( | const OtherType & | other | ) | const
| inline

Returns true if the current value of the property (or the fallback value) is equal to other.

Definition at line 120 of file juce_CachedValue.h.

## ◆ referTo() [1/2]

template<typename Type >

void juce::CachedValue< Type >::referTo | ( | ValueTree & | tree,
|  | const Identifier & | property,
|  | UndoManager * | um
| ) |  |
| inline

Makes the CachedValue refer to the specified property inside the given ValueTree.

Definition at line 270 of file juce_CachedValue.h.

## ◆ referTo() [2/2]

template<typename Type >

void juce::CachedValue< Type >::referTo | ( | ValueTree & | tree,
|  | const Identifier & | property,
|  | UndoManager * | um,
|  | const Type & | defaultVal
| ) |  |
| inline

Makes the CachedValue refer to the specified property inside the given ValueTree, and specifies a fallback value to use if the property does not exist.

Definition at line 276 of file juce_CachedValue.h.

## ◆ resetToDefault() [1/2]

template<typename Type >

void juce::CachedValue< Type >::resetToDefault
| inline

Removes the property from the referenced ValueTree and makes the CachedValue return the fallback default value instead.

Definition at line 257 of file juce_CachedValue.h.

## ◆ resetToDefault() [2/2]

template<typename Type >

void juce::CachedValue< Type >::resetToDefault | ( | UndoManager * | undoManagerToUse | ) |
| inline

Removes the property from the referenced ValueTree and makes the CachedValue return the fallback default value instead.

Definition at line 263 of file juce_CachedValue.h.

## ◆ setDefault()

template<typename Type >

void juce::CachedValue< Type >::setDefault | ( | const Type & | value | ) |
| inline

Resets the fallback default value.

Definition at line 158 of file juce_CachedValue.h.

## ◆ setValue()

template<typename Type >

void juce::CachedValue< Type >::setValue | ( | const Type & | newValue,
|  | UndoManager * | undoManagerToUse
| ) |  |
| inline

Sets the property. This will actually modify the property in the referenced ValueTree.

Definition at line 247 of file juce_CachedValue.h.

The documentation for this class was generated from the following file:

- juce_CachedValue.h